package net.sf.ejp.tools.formatonsave.core;

import net.sf.ejp.tools.formatonsave.core.actions.PatchedFormatAllAction_r1_7_4_1;
import net.sf.ejp.tools.formatonsave.core.actions.PatchedOrganizeImportsAction_r1_47;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.internal.ui.javaeditor.ISavePolicy;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchSite;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;

public class EditorSavePolicy implements ISavePolicy
{
  public void preSave(ICompilationUnit _unit)
  {
    Logger.log("preSave", _unit.getPath());

    IWorkbench workbench = PlatformUI.getWorkbench();
    IWorkbenchWindow workbenchWindow = workbench.getActiveWorkbenchWindow();
    IWorkbenchPage workbenchPage = workbenchWindow.getActivePage();
    IWorkbenchPart workbenchPart = workbenchPage.getActivePart();
    IWorkbenchSite workbenchSite = workbenchPart.getSite();

    boolean success = false;
    PatchedOrganizeImportsAction_r1_47 organizeImportsAction = new PatchedOrganizeImportsAction_r1_47(
        workbenchSite);
    try
    {
      organizeImportsAction.run(_unit);
      success = true;
    }
    catch (Throwable t)
    {
      Logger.logError(ErrorCodes.ORGANIZE_IMPORTS_FAILED, "Failed to organize imports", t);
    }

    if (success)
    {
      PatchedFormatAllAction_r1_7_4_1 formatAllAction = new PatchedFormatAllAction_r1_7_4_1(workbenchSite);
      try
      {
        formatAllAction.runOnMultiple(new ICompilationUnit[]
        { _unit });
        success = true;
      }
      catch (Throwable t)
      {
        Logger.logError(ErrorCodes.FORMAT_SOURCE_FAILED, "Failed to format source", t);
      }
    }
  }

  public ICompilationUnit postSave(ICompilationUnit _unit)
  {
    Logger.log("postSave", _unit.getPath());
    return null;
  }
}
