package net.sf.ejp.tools.formatonsave.core;

import java.io.File;
import java.io.FileWriter;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

public final class Logger
{
  private static final DateFormat DATE_FORMAT = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss.SSS");

  private static final boolean LOG_TO_FILE = false;

  public static void log(String _mthd, Object _args)
  {
    log(_mthd + "(" + _args + ")");
  }

  public static void log(String _msg)
  {
    if (LOG_TO_FILE)
    {
      try
      {
        File f = new File("c:/temp/formatonsave.log");
        FileWriter fw = new FileWriter(f, true);
        fw.write(DATE_FORMAT.format(new Date()) + "\t\t" + _msg + "\n");
        fw.close();
      }
      catch (Throwable t)
      {
        logErrorInEclipse(ErrorCodes.LOGGER_FAILED, "Failed to log message " + _msg, t);
      }
    }
  }

  public static void logError(int _code, String _message, Throwable _exception)
  {
    log("ERROR #" + _code + ": " + _message);
    logErrorInEclipse(_code, _message, _exception);
  }

  private static void logErrorInEclipse(int _code, String _message, Throwable _exception)
  {
    FormatOnSavePlugin.getDefault().getLog().log(
        new Status(IStatus.ERROR, FormatOnSavePlugin.getDefault().getBundle().getSymbolicName(),
            _code, _message, _exception));
  }
}
